let helpers = require('../../helpers');

module.exports = {
    tag: 'Price',
    array: true,
    fields: {
        code: {
            tag: 'PriceTypeCode',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number,
            default: 1
        },
        qualifier: {
            tag: 'PriceQualifier',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number,
            default: 5
        },
        amount: {
            tag: 'PriceAmount',
            transform: Number
        },
        currency: {
            tag: 'CurrencyCode',
            transform: function(s) { return s.toUpperCase(); },
            untransform: Number,
            default: 'USD'
        }
    },
    map: {
        to: 'amount'
    }
};
