let helpers = require('../../helpers');
let Price = require('./price');
let Title = require('./title');
let Language = require('./language');
let ProductId = require('./productid');
let WorkId = require('./workid');
let Contributor = require('./contributor');
let Subject = require('./subject');
let Audience = require('./audience');
let SupplyDetail = require('./supplydetail');
let MediaFile = require('./mediafile');
let OtherText = require('./othertext');
let Imprint = require('./imprint');
let Publisher = require('./publisher');
let SalesRights = require('./salesright');

module.exports = {
    tag: 'Product',
    array: true,
    fields: {
        'record': {
            tag: 'RecordReference',
            raw: true
        },
        'notification': {
            tag: 'NotificationType',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number
        },
        'publishingStatus': {
            tag: 'PublishingStatus',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number
        },
        'id': ProductId,
        'workId': WorkId,
        'form': {
            tag: 'ProductForm',
            transform: String
        },
        'epubType': {
            tag: 'EpubType',
            transform: helpers.partialRight(helpers.pad, 3),
            untransform: Number,
        },
        'cityOfPublication': {
            tag: 'CityOfPublication'
        },
        'countryOfPublication': {
            tag: 'CountryOfPublication'
        },
        'publicationDate': {
            tag: 'PublicationDate',
            transform: helpers.formatDate,
            untransform: helpers.parseDate
        },
        'title': Title,
        'prices': Price,
        'language': Language,
        'contributors': Contributor,
        'subjects': Subject,
        'audiences': Audience,
        'medias': MediaFile,
        'supply': SupplyDetail,
        'texts': OtherText,
        'imprint': Imprint,
        'publisher': Publisher,
        'salesRights': SalesRights,
        'numberOfPages': {
            tag: 'NumberOfPages',
            untransform: Number
        },
    }
};
