// noinspection JSCheckFunctionSignatures

let helpers = require('../../helpers');

module.exports = {
    tag: 'Subject',
    array: true,
    fields: {
        identifier: {
            tag: 'SubjectSchemeIdentifier',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number,
            default: 10
        },
        version: {
            tag: 'SubjectSchemeVersion'
        },
        code: {
            tag: 'SubjectCode',
            transform: function(s) { return String(s).toUpperCase(); }
        },
        heading: {
            tag: 'SubjectHeadingText'
        },
        main: {
            tag: 'MainSubject',
            bool: true
        }
    },
    map: {
        to: 'code'
    }
};
