let helpers = require('../../helpers');
let SupportingResource = require('./supportingresource');

module.exports = {
    tag: 'CollateralDetail',
    fields: {
        'textContent': { // P.14
            tag: 'TextContent',
            fields: {
                'type': { // P.14.1
                    tag: 'TextType',
                    transform: helpers.partialRight(helpers.pad, 2),
                    untransform: Number,
                    default: 3
                },
                'audience': {
                    tag: 'ContentAudience',
                    transform: helpers.partialRight(helpers.pad, 2),
                    untransform: Number,
                    default: 0
                },
              'text': { // P.14.3
                tag: 'Text',
                cdata: true
              }
            },
            array: true
        },
        'supportingResource': SupportingResource // P.16
    }
};
