// noinspection JSCheckFunctionSignatures

let helpers = require('../../helpers');
let Sender = require('./sender');
let Addressee = require('./addressee');

module.exports = {
    tag: 'Header',
    fields: {
        'sender': Sender,
        'addressee': Addressee,
        'sentDateTime': {
            tag: 'SentDateTime',
            transform: helpers.formatDate,
            untransform: helpers.parseDate
        },
        'defaultLanguageOfText': {
            tag: 'DefaultLanguageOfText',
            transform: function(s) { return String(s).toLowerCase(); },
            untransform: String,
        },
        'defaultCurrencyCode': {
            tag: 'DefaultCurrencyCode',
            transform: function(s) { return s.toUpperCase(); },
            default: "USD"
        }
    }
};
