let helpers = require('../../helpers');
let OnixDate = require('./onixdate');

module.exports = {
    tag: 'MarketPublishingDetail',
    fields: {
        'status': {
          tag: 'MarketPublishingStatus', // P.25.12
          transform: helpers.partialRight(helpers.pad, 2),
          untransform: Number
        },
        'dates': {
          tag: 'MarketDate',
          fields: {
            'role': {
              tag: 'MarketDateRole',  // P.25.14
              transform: helpers.partialRight(helpers.pad, 2),
              untransform: Number
            },
            'date': OnixDate
          },
          array: true,
          map: {
            to: 'date'
          }
        }
      },
    array: true
};
