let helpers = require('../../helpers');
let ProductId = require('./productid');
let RecordSourceId = require('./recordsource');
let Barcode = require('./barcode');
let ProductDescription = require('./productdescription');
let CollateralDetail = require('./collateraldetail');
let PublishingDetail = require('./publishingdetail');
let ProductSupply = require('./productsupply');
let RelatedMaterial = require('./relatedmaterial');

module.exports = {
    tag: 'Product',
    array: true,
    fields: {
        'record': {
            tag: 'RecordReference', // Group P.1
            raw: true
        },
        'recordSourceId': RecordSourceId,
        'notification': {
            tag: 'NotificationType',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number
        },
        'identifiers': ProductId, // Group P.2
        'barcode': Barcode,
        'description': ProductDescription, // Block 1
        'collateralDetail': CollateralDetail, // Block 2
        'publishingDetail': PublishingDetail, // Block 4
        'relatedMaterial': RelatedMaterial, // Block 5
        'productSupply': ProductSupply // Block 6
      }
};
