let helpers = require('../../helpers');
let Title = require('./title');
let Contributor = require('./contributor');
let Language = require('./language');
let Subject = require('./subject');
let Collection = require('./collection');
let Audience = require('./audience');

module.exports = {
    tag: 'DescriptiveDetail',
    fields: {
        'productComposition': {
            tag: 'ProductComposition',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number,
            default: 1
        },
        'productPackaging': {
            tag: 'ProductPackaging',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number
        },
        'epubProtection': {
            tag: 'EpubTechnicalProtection',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number
        },
        'editionType': {
            tag: 'EditionType',
            transform: function(s) { return s.toUpperCase(); }
        },
        'productForm': {  // Block P.3.2
          tag: 'ProductForm',
          transform: String
        },
        'productFormDetails': {   // Block P.3.3
          tag: 'ProductFormDetail',
          transform: String,
          array: true
        },
        'collection': Collection, // Group P.5
        'title': Title, // Group P.6
        'contributors': Contributor, // Group P.7
        'audiences': Audience,
        'languages': Language, // Group P.10
        'subjects': Subject
    }, map: {
      to: 'title'
    }
};
