let helpers = require('../../helpers');
let ProductID = require('./productid');

module.exports = {
    tag: 'RelatedMaterial', // Block 5
    fields: {
        'relatedWork': {
            tag: 'RelatedWork',
            fields: {
                'workRelationCode': {
                    tag: 'WorkRelationCode',
                    transform: helpers.partialRight(helpers.pad, 2),
                    untransform: Number
                },
                'workIdentifiers': {
                    tag: 'WorkIdentifier',
                    fields: {
                        'type': {
                            tag: 'WorkIDType',
                            transform: helpers.partialRight(helpers.pad, 2),
                            untransform: Number,
                            default: 1
                        },
                        'typeValue': {
                            tag: 'IDTypeName',
                            transform: String
                        },
                        'value': {
                            tag: 'IDValue',
                            transform: String
                        }
                    },
                    array: true,
                }
            },
            array: true
        },
        'relatedProducts': {  // Group P.23
            tag: 'RelatedProduct',
            fields: {
                'productRelationCodes': {  // Group P.23.1
                    tag: 'ProductRelationCode',
                    array: true,
                    transform: helpers.partialRight(helpers.pad, 2),
                    untransform: Number
                },
                'productIdentifiers': ProductID,
                'productForm': {  // Group P.23.5
                    tag: 'ProductForm',
                    transform: String
                },
                'productFormDetails': {
                    tag: 'ProductFormDetail',
                    transform: String,
                    array: true
                }
            },
            array: true
        }
    }
};
