let helpers = require('../../helpers');
let Price = require('./price');
let OnixDate = require('./onixdate');

module.exports = {
    tag: 'SupplyDetail', // Group P.26
    fields: {
        suppliers : {
            array: true,
            tag: 'Supplier',
            fields: {
                name: {
                    tag: 'SupplierName'
                },
                role: {
                    tag: 'SupplierRole',
                    transform: helpers.partialRight(helpers.pad, 2),
                    untransform: Number
                },
            }
        },
        availability: {
            tag: 'ProductAvailability', // P.26.17
            default: 20,
            transform: String,
            untransform: Number
        },
        dates: {
            tag: 'SupplyDate',
            fields: {
                role: {
                  tag: 'SupplyDateRole', // P.26.18
                  transform: helpers.partialRight(helpers.pad, 2),
                  untransform: Number
                },
                date: OnixDate // P.26.20
            },
            array: true
        },
        prices: Price // P.26.42
    },
    array: true
};
