let helpers = require('../../helpers');

module.exports = {
    tag: 'TitleDetail',
    fields: {
        'type': {
            tag: 'TitleType',
            transform: helpers.partialRight(helpers.pad, 2),
            untransform: Number,
            default: 1
        },
        'element': {
            tag: 'TitleElement',
            fields: {
              'level': {
                tag: 'TitleElementLevel',
                transform: helpers.partialRight(helpers.pad, 2),
                untransform: Number,
                default: 1
              },
              'text': {
                tag: 'TitleText',
                cdata: true,
                default: ""
              },
                'noPrefix': {
                  tag: 'NoPrefix',
                    default: false,
                    bool: true
                },
                'withoutPrefix': {
                    tag: 'TitleWithoutPrefix',
                    cdata: true
                },
                'subtitle': {
                    tag: 'Subtitle',
                    cdata: true
                }
            },
            map: {
              to: 'text'
            }
        }
    },
    map: {
        to: 'element'
    }
};
